/*
 * Cat.java
 *
 * Copyright (c) 2013 Jessica Hu. All Rights Reserved.
 *
 * history:
 *      jhu 11april2013: began program
 *
 */

import java.awt.*;
import java.util.Random;

/**
 * 
 * @version 1.0 11 April 2013
 * @author Jessica Hu
 *
 * The model of the cat
 *
 */
public class Cat
{
   //picture of cat
   Image catImage = Toolkit.getDefaultToolkit().createImage("cat.png");
   Random randGenerator = new Random();
   
   private final int ACCELERATION_GRAVITY = 2;
   private final int MULTIPLIER = 2;
   
   int velX, velY;
   private int currentForce;
   
   private int coordX;           // x and y coordinates upper left
   private int coordY;
   
   private int rightBound;  // Maximum x, y values.
   private int bottomBound;
   
   /**
    *  Model and logic of a cat.
    */
   public Cat(int inputTotalForce)
   { 
       currentForce = inputTotalForce*MULTIPLIER;
       
       setVelocities();

       coordX = 220;
       coordY = 220;
   }
   
   public void move()
   {
       coordX -= velX;
       coordY -= velY;
       
       //if cats go to top edge, bounce off
       if (coordY < 0)
       {
           coordY = 0;
           velY = -velY;
        }
       else if (coordY > bottomBound || coordX < -50 || coordX > rightBound)
            //if off the screen, reset position
       {
           coordX = rightBound/2-20;
           coordY = bottomBound/2-10;
           setVelocities();
        }
        

       velY -= ACCELERATION_GRAVITY;
    }
   
   public void setBounds(int width, int height) 
   {
        rightBound  = width;
        bottomBound = height;
    }
    
   public void setCurrentForce(int inputCurrentForce)
   {
       currentForce = inputCurrentForce*MULTIPLIER;
    }
    
   public int getCurrentForce()
   {
      return currentForce/MULTIPLIER;
   }
   
   /**
    * A method that resets the X and Y velocities everytime the cat goes back to the initial position
    */
   public void setVelocities()
   { 
       velX = randGenerator.nextInt(currentForce*2 + 1)- currentForce;
       velY = currentForce - Math.abs(velX);
    }
   
   public void draw(Graphics g) 
   {
        g.drawImage(catImage, coordX, coordY, null);
    }
}
