/*
 * Cat.java
 *
 * Copyright (c) 2013 Jessica Hu. All Rights Reserved.
 *
 * history:
 *      jhu 08april2013: began program
 *
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import java.applet.*;
import sun.audio.*;

/**
 * 
 * @version 1.0 08 April 2013
 * @author Jessica Hu
 *
 */
public class CatApplet extends JApplet implements ActionListener
{
   private final int APPLET_WIDTH = 500;
   private final int APPLET_HEIGHT = 500;
   private final int DEFAULT_FORCE = 5;
      
   //initializes the labels, panels, and buttons
   private JLabel titleLabel, forceLabel;
   private JButton increase, decrease;
   private CatGraphicsPanel mainPanel;
   private JPanel forceUpdatePanel, appletPanel;
   
   /**
    * Creates and displays the application frame.
    */
   public void init()
   {
      forceUpdatePanel = new JPanel ();
      forceUpdatePanel.setLayout (new BoxLayout(forceUpdatePanel, BoxLayout.X_AXIS));
      forceUpdatePanel.setOpaque (false);

      titleLabel = new JLabel ("Cats!");
      titleLabel.setForeground (Color.black);
      
      //create and format buttons, labels, adding ActionListeners
      increase = new JButton (new ImageIcon ("increase.gif"));
      increase.setPressedIcon (new ImageIcon ("increasePressed.gif"));
      increase.setPreferredSize(new Dimension(30, 30));
      increase.addActionListener (this);
      
      decrease = new JButton (new ImageIcon ("decrease.gif"));
      decrease.setPressedIcon (new ImageIcon ("decreasePressed.gif"));
      decrease.setPreferredSize(new Dimension(30, 30));
      decrease.addActionListener (this);      

      forceLabel = new JLabel ("Force: " + DEFAULT_FORCE);
      forceLabel.setForeground (Color.black);
      
      //adds all of the buttons, etc. to the panel
      forceUpdatePanel.add (titleLabel);
      forceUpdatePanel.add (Box.createHorizontalStrut (50));
      forceUpdatePanel.add (decrease);
      forceUpdatePanel.add (increase);
      forceUpdatePanel.add (Box.createHorizontalStrut (50));
      forceUpdatePanel.add (forceLabel);

      mainPanel = new CatGraphicsPanel (DEFAULT_FORCE);
      
      //large panel that encompasses the buttons as well as the fountain
      appletPanel = new JPanel();
      appletPanel.add (forceUpdatePanel);
      appletPanel.add (mainPanel);

      getContentPane().add (appletPanel);

      setSize (APPLET_WIDTH, APPLET_HEIGHT);
   }
   
   /**
    * Determines the value of the force depending on which button was pressed, and sets the values
    */
   public void actionPerformed (ActionEvent event)
   {
      if (event.getSource() == increase && mainPanel.getTotalForce() < mainPanel.getMaxForce()) 
      //increments and decrements force if within maximum force
      {
          mainPanel.setTotalForce(mainPanel.getTotalForce() + 1);
        }
      else if (event.getSource() == decrease && mainPanel.getTotalForce() > 1)
      {
          mainPanel.setTotalForce(mainPanel.getTotalForce() - 1);
        }
      
      forceLabel.setText ("Force: " + mainPanel.getTotalForce());
      
      repaint();
   }
}
